//+------------------------------------------------------------------+
//|                                                          Magarto |
//+------------------------------------------------------------------+
 

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  DimGray
#property indicator_color2  Lime
#property indicator_color3  Red
#property indicator_level1  3
#property indicator_level2  2
#property indicator_level3  0
#property indicator_level4  -2
#property indicator_level5  -3
#property indicator_maximum 3.25
#property indicator_minimum -3.25

extern int    MAPeriod           = 30;
extern int    MAMode             = MODE_SMA;
extern int    xMAPeriod          = 13;
extern int    xMAMode            = MODE_EMA;
extern int    Price              = PRICE_CLOSE;
extern color  ArrowsOBColor      = Lime;
extern color  ArrowsOSColor      = Red;
extern int    ArrowsDisplacement = 0.0;
extern int    ArrowsOBCode       = 108;
extern int    ArrowsOSCode       = 108;
extern string ArrowsCodes        = "http://docs.mql4.com/constants/objectconstants/wingdings";
extern bool   alertsOn           = true;
extern bool   alertsOnCurrent    = false;
extern bool   alertsMessage      = true;
extern bool   alertsSound        = false;
extern bool   alertsNotify       = true;
extern bool   alertsEmail        = true;
extern string soundFile          = "alert2.wav"; 


double all4[];
double ma[];
double maslopeB[];
double candleOver[];
double bothElder[];
double ArrowsOB[];
double ArrowsOS[];
double trend[];
 
int init()
{
   IndicatorBuffers(8);
      SetIndexBuffer(0,all4);
      SetIndexBuffer(1,ArrowsOB);   SetIndexArrow(1,ArrowsOBCode);   SetIndexStyle(1,DRAW_ARROW,EMPTY,EMPTY,ArrowsOBColor);
      SetIndexBuffer(2,ArrowsOS);   SetIndexArrow(2,ArrowsOSCode);   SetIndexStyle(2,DRAW_ARROW,EMPTY,EMPTY,ArrowsOSColor);
      SetIndexBuffer(3,ma);
      SetIndexBuffer(4,maslopeB);
      SetIndexBuffer(5,candleOver);
      SetIndexBuffer(6,bothElder);
      SetIndexBuffer(7,trend);

   IndicatorShortName("Magarto");
   return(0);
}

int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{
   int counted_bars = IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   for(i=limit; i>=0; i--)
   {
      ma[i]          = iMA(NULL,0,MAPeriod,0,MAMode,Price,i);
      double maslope = ma[i] - ma[i+2];
      
      if(maslope < 0)          maslopeB[i] = -1;
      else if(maslope > 0)     maslopeB[i] =  1;
      else                     maslopeB[i] =  0;

      if(((Open[i] + High[i] + Low[i] + Close[i]) / 4) > ma[i]) candleOver[i] = 1; else candleOver[i] = -1;

      double xMA = iMA(NULL,0,xMAPeriod,0,xMAMode,Price,i);

      double DayLow;
      if(iTime(NULL,PERIOD_D1,i) != iTime(NULL,PERIOD_D1,i+1)) DayLow = Low[i];
      else if(Low[i+1] != EMPTY_VALUE)                         DayLow = MathMin(Low[i],Low[i+1]);
      else                                                     DayLow = MathMin(Low[i],0);

      double DayHigh;
      if(iTime(NULL,PERIOD_D1,i) != iTime(NULL,PERIOD_D1,i+1)) DayHigh = High[i];
      else if(High[i+1] != EMPTY_VALUE)                        DayHigh = MathMax(High[i],High[i+1]);
      else                                                     DayHigh = MathMax(High[i],0);

      double bearpower = DayLow - xMA;
      double bullpower = DayHigh - xMA;

      if     (bearpower > 0 && bullpower > 0) bothElder[i] =  1;
      else if(bearpower < 0 && bullpower < 0) bothElder[i] = -1;
      else                                    bothElder[i] =  0;

      all4[i] = maslopeB[i] + candleOver[i] + bothElder[i];
      
      ArrowsOB[i] = EMPTY_VALUE;
      ArrowsOS[i] = EMPTY_VALUE;
      trend[i] = 0;
      if(all4[i] >=  3) trend[i] =-1;
      if(all4[i] <= -3) trend[i] = 1;
      if(trend[i] ==-1) ArrowsOB[i] = all4[i];  
      if(trend[i] == 1) ArrowsOS[i] = all4[i];
   }

   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
     if (alertsOnCurrent)
          int whichBar = 0;
     else     whichBar = 1;
         
     if (trend[whichBar] != trend[whichBar+1])
     if (trend[whichBar] == 1)
           doAlert("oversold");
     else  doAlert("overbought");       
  }
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

           message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Magarto ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(), Period(), " Magarto  "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
} 